/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 11 "trafgen_parser.y" /* yacc.c:339  */


#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <stdint.h>
#include <errno.h>
#include <stdbool.h>
#include <libgen.h>

#include "xmalloc.h"
#include "trafgen_parser.tab.h"
#include "trafgen_conf.h"
#include "built_in.h"
#include "die.h"
#include "str.h"
#include "csum.h"

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYENABLE_NLS		1
#define YYLTYPE_IS_TRIVIAL	1
#define ENABLE_NLS		1

extern FILE *yyin;
extern int yylex(void);
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

extern struct packet *packets;
extern size_t plen;

#define packet_last		(plen - 1)

#define payload_last		(packets[packet_last].len - 1)

extern struct packet_dyn *packet_dyn;
extern size_t dlen;

#define packetd_last		(dlen - 1)

#define packetdc_last		(packet_dyn[packetd_last].clen - 1)
#define packetdr_last		(packet_dyn[packetd_last].rlen - 1)
#define packetds_last		(packet_dyn[packetd_last].slen - 1)

static int our_cpu, min_cpu = -1, max_cpu = -1;

static inline int test_ignore(void)
{
	if (min_cpu < 0 && max_cpu < 0)
		return 0;
	else if (max_cpu >= our_cpu && min_cpu <= our_cpu)
		return 0;
	else
		return 1;
}

static inline int has_dynamic_elems(struct packet_dyn *p)
{
	return (p->rlen + p->slen + p->clen);
}

static inline void __init_new_packet_slot(struct packet *slot)
{
	slot->payload = NULL;
	slot->len = 0;
}

static inline void __init_new_counter_slot(struct packet_dyn *slot)
{
	slot->cnt = NULL;
	slot->clen = 0;
}

static inline void __init_new_randomizer_slot(struct packet_dyn *slot)
{
	slot->rnd = NULL;
	slot->rlen = 0;
}

static inline void __init_new_csum_slot(struct packet_dyn *slot)
{
	slot->csum = NULL;
	slot->slen = 0;
}

static inline void __setup_new_counter(struct counter *c, uint8_t start,
				       uint8_t stop, uint8_t stepping,
				       int type)
{
	c->min = start;
	c->max = stop;
	c->inc = stepping;
	c->val = (type == TYPE_INC) ? start : stop;
	c->off = payload_last;
	c->type = type;
}

static inline void __setup_new_randomizer(struct randomizer *r)
{
	r->off = payload_last;
}

static inline void __setup_new_csum16(struct csum16 *s, off_t from, off_t to,
				      enum csum which)
{
	s->off = payload_last - 1;
	s->from = from;
	s->to = to;
	s->which = which;
}

static void realloc_packet(void)
{
	if (test_ignore())
		return;

	plen++;
	packets = xrealloc(packets, 1, plen * sizeof(*packets));

	__init_new_packet_slot(&packets[packet_last]);

	dlen++;
	packet_dyn = xrealloc(packet_dyn, 1, dlen * sizeof(*packet_dyn));

	__init_new_counter_slot(&packet_dyn[packetd_last]);
	__init_new_randomizer_slot(&packet_dyn[packetd_last]);
	__init_new_csum_slot(&packet_dyn[packetd_last]);
}

static void set_byte(uint8_t val)
{
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);
	pkt->payload[payload_last] = val;
}

static void set_multi_byte(uint8_t *s, size_t len)
{
	size_t i;

	for (i = 0; i < len; ++i)
		set_byte(s[i]);
}

static void set_fill(uint8_t val, size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = val;
}

static void __set_csum16_dynamic(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	pkt->len += 2;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);

	pktd->slen++;
	pktd->csum = xrealloc(pktd->csum, 1, pktd->slen * sizeof(struct csum16));

	__setup_new_csum16(&pktd->csum[packetds_last], from, to, which);
}

static void __set_csum16_static(size_t from, size_t to, enum csum which __maybe_unused)
{
	struct packet *pkt = &packets[packet_last];
	uint16_t sum;
	uint8_t *psum;

	sum = htons(calc_csum(pkt->payload + from, to - from, 0));
	psum = (uint8_t *) &sum;

	set_byte(psum[0]);
	set_byte(psum[1]);
}

static void set_csum16(size_t from, size_t to, enum csum which)
{
	int make_it_dynamic = 0;
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	if (to < from) {
		size_t tmp = to;

		to = from;
		from = tmp;
	}

	bug_on(!(from < to));

	if (to >= pkt->len || which == CSUM_TCP || which == CSUM_UDP)
		make_it_dynamic = 1;

	if (has_dynamic_elems(pktd) || make_it_dynamic)
		__set_csum16_dynamic(from, to, which);
	else
		__set_csum16_static(from, to, which);
}

static void set_rnd(size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = (uint8_t) rand();
}

static void set_sequential_inc(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);
	for (i = 0; i < len; ++i) {
		off_t off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start += stepping;
	}
}

static void set_sequential_dec(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);
	for (i = 0; i < len; ++i) {
		int off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start -= stepping;
	}
}

static void set_dynamic_rnd(void)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);

	pktd->rlen++;
	pktd->rnd = xrealloc(pktd->rnd, 1, pktd->rlen *	sizeof(struct randomizer));

	__setup_new_randomizer(&pktd->rnd[packetdr_last]);
}

static void set_dynamic_incdec(uint8_t start, uint8_t stop, uint8_t stepping,
			       int type)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, 1, pkt->len);

	pktd->clen++;
	pktd->cnt =xrealloc(pktd->cnt, 1, pktd->clen * sizeof(struct counter));

	__setup_new_counter(&pktd->cnt[packetdc_last], start, stop, stepping, type);
}


#line 372 "trafgen/trafgen_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "trafgen_parser.tab.h".  */
#ifndef YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
# define YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    K_COMMENT = 258,
    K_FILL = 259,
    K_RND = 260,
    K_SEQINC = 261,
    K_SEQDEC = 262,
    K_DRND = 263,
    K_DINC = 264,
    K_DDEC = 265,
    K_WHITE = 266,
    K_CPU = 267,
    K_CSUMIP = 268,
    K_CSUMUDP = 269,
    K_CSUMTCP = 270,
    K_CONST8 = 271,
    K_CONST16 = 272,
    K_CONST32 = 273,
    K_CONST64 = 274,
    number = 275,
    string = 276
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 317 "trafgen_parser.y" /* yacc.c:355  */

	long long int number;
	char *str;

#line 439 "trafgen/trafgen_parser.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 454 "trafgen/trafgen_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   209

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  40
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  65
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  172

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   276

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    32,    33,     2,
      23,    24,    30,    29,    20,    28,     2,    31,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    27,     2,
      35,     2,    36,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    25,     2,    26,    37,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    21,    34,    22,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    38,    39
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   337,   337,   338,   339,   340,   344,   348,   349,   353,
     354,   358,   359,   360,   364,   368,   381,   388,   389,   393,
     394,   398,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   417,   419,   421,   423,   425,   427,
     429,   431,   433,   435,   437,   439,   441,   446,   451,   453,
     458,   463,   471,   476,   478,   480,   485,   487,   492,   494,
     499,   501,   510,   512,   517,   519
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_COMMENT", "K_FILL", "K_RND",
  "K_SEQINC", "K_SEQDEC", "K_DRND", "K_DINC", "K_DDEC", "K_WHITE", "K_CPU",
  "K_CSUMIP", "K_CSUMUDP", "K_CSUMTCP", "K_CONST8", "K_CONST16",
  "K_CONST32", "K_CONST64", "','", "'{'", "'}'", "'('", "')'", "'['",
  "']'", "':'", "'-'", "'+'", "'*'", "'/'", "'%'", "'&'", "'|'", "'<'",
  "'>'", "'^'", "number", "string", "$accept", "packets", "inline_comment",
  "cpu_delim", "delimiter_nowhite", "noenforce_white", "packet", "payload",
  "delimiter", "elem_delimiter", "elem", "expression", "fill", "const",
  "rnd", "csum", "seqinc", "seqdec", "drnd", "dinc", "ddec", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      44,   123,   125,    40,    41,    91,    93,    58,    45,    43,
      42,    47,    37,    38,   124,    60,    62,    94,   275,   276
};
# endif

#define YYPACT_NINF -136

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-136)))

#define YYTABLE_NINF -14

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -136,    10,  -136,  -136,  -136,   -16,    26,  -136,  -136,   -30,
    -136,     3,  -136,    88,    58,  -136,    13,    33,    34,    37,
      44,    46,    60,    61,    66,    67,    76,    77,    86,    87,
    -136,  -136,  -136,    28,  -136,  -136,  -136,  -136,  -136,  -136,
    -136,  -136,  -136,  -136,    -1,  -136,  -136,    -5,     6,    73,
      74,    78,   -18,    80,    81,    82,    84,    85,     2,     2,
       2,     2,    93,   106,   107,    88,  -136,    26,   108,    48,
     109,    48,    48,  -136,   111,    48,    48,    48,    48,    48,
       2,     2,  -136,    42,   110,   124,   138,  -136,  -136,   115,
     103,  -136,  -136,   126,  -136,   127,   139,  -136,   140,   141,
     153,   154,   155,   152,  -136,  -136,     2,     2,     2,     2,
       2,     2,     2,    96,   113,     2,  -136,  -136,  -136,    26,
      26,   166,    18,    21,    23,    97,   170,   171,   172,  -136,
    -136,  -136,  -136,  -136,  -136,  -136,  -136,     2,     2,  -136,
      88,   176,  -136,  -136,   160,  -136,   161,  -136,   162,  -136,
     163,  -136,  -136,  -136,  -136,  -136,    28,    26,   178,   179,
     180,   181,   184,    88,  -136,  -136,  -136,  -136,  -136,    28,
     185,  -136
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     6,     5,     0,    11,     4,     3,     0,
      12,     9,    13,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    23,    33,    11,    17,    24,    32,    25,    31,    27,
      28,    26,    29,    30,     0,     7,     8,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    20,    19,     0,     0,    18,    11,     0,     0,
       0,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,    14,    21,     0,
       0,    20,    19,     0,    52,     0,     0,    61,     0,     0,
       0,     0,     0,     0,    45,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,    50,    51,    11,
      11,     0,     0,     0,     0,     0,     0,     0,     0,    46,
      36,    35,    37,    38,    39,    40,    41,     0,     0,    42,
       0,     0,    47,    56,     0,    58,     0,    62,     0,    64,
       0,    53,    55,    54,    43,    44,    11,    11,     0,     0,
       0,     0,     0,     0,    57,    59,    63,    65,    16,    11,
       0,    15
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -136,  -136,   207,  -136,    -6,   -32,  -136,  -135,   -60,  -136,
     144,   -57,  -136,  -136,  -136,  -136,  -136,  -136,  -136,  -136,
    -136
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,    32,    47,    92,    13,     8,    33,    65,    66,
      34,    83,    35,    36,    37,    38,    39,    40,    41,    42,
      43
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      12,    64,    84,    85,    86,   156,    73,     9,    14,    93,
       2,    95,    96,     3,    15,    98,    99,   100,   101,   102,
      74,     4,     5,   103,   104,    80,    67,    63,   169,    91,
      81,     6,    91,    68,    91,    89,    48,    10,    11,    62,
      82,    11,   143,    11,    69,   145,    11,   147,    11,   130,
     131,   132,   133,   134,   135,   136,    49,    50,   139,    91,
      51,    12,   144,   146,   148,   150,   105,    52,    11,    53,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     154,   155,    44,    54,    55,    45,    46,   140,   141,    56,
      57,     3,    16,    17,    18,    19,    20,    21,    22,    58,
      59,    23,    24,    25,    26,    27,    28,    29,    91,    60,
      61,    70,    71,    12,    12,   -12,    72,    11,    75,    76,
      77,   149,    78,    79,   162,   163,    30,    31,   -13,    87,
     120,   137,    90,    94,   116,    97,   119,   170,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   117,   138,
      63,    12,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   118,    63,   121,   122,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   129,   123,   124,   125,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     142,   126,   127,   128,   151,   152,   153,   157,   158,   159,
     160,   161,   164,   165,   166,   167,   168,   171,     7,    88
};

static const yytype_uint8 yycheck[] =
{
       6,    33,    59,    60,    61,   140,    24,    23,    38,    69,
       0,    71,    72,     3,    11,    75,    76,    77,    78,    79,
      38,    11,    12,    80,    81,    23,    27,    33,   163,    11,
      28,    21,    11,    38,    11,    67,    23,    11,    20,    11,
      38,    20,    24,    20,    38,    24,    20,    24,    20,   106,
     107,   108,   109,   110,   111,   112,    23,    23,   115,    11,
      23,    67,   122,   123,   124,   125,    24,    23,    20,    23,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
     137,   138,    24,    23,    23,    27,    28,   119,   120,    23,
      23,     3,     4,     5,     6,     7,     8,     9,    10,    23,
      23,    13,    14,    15,    16,    17,    18,    19,    11,    23,
      23,    38,    38,   119,   120,    22,    38,    20,    38,    38,
      38,    24,    38,    38,   156,   157,    38,    39,    22,    22,
      27,    35,    24,    24,    24,    24,    21,   169,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    24,    36,
     156,   157,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    24,   169,    38,    38,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    24,    38,    38,    38,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      24,    38,    38,    38,    24,    24,    24,    21,    38,    38,
      38,    38,    24,    24,    24,    24,    22,    22,     1,    65
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    41,     0,     3,    11,    12,    21,    42,    46,    23,
      11,    20,    44,    45,    38,    11,     4,     5,     6,     7,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      38,    39,    42,    47,    50,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    24,    27,    28,    43,    23,    23,
      23,    23,    23,    23,    23,    23,    23,    23,    23,    23,
      23,    23,    11,    44,    45,    48,    49,    27,    38,    38,
      38,    38,    38,    24,    38,    38,    38,    38,    38,    38,
      23,    28,    38,    51,    51,    51,    51,    22,    50,    45,
      24,    11,    44,    48,    24,    48,    48,    24,    48,    48,
      48,    48,    48,    51,    51,    24,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    24,    24,    24,    21,
      27,    38,    38,    38,    38,    38,    38,    38,    38,    24,
      51,    51,    51,    51,    51,    51,    51,    35,    36,    51,
      45,    45,    24,    24,    48,    24,    48,    24,    48,    24,
      48,    24,    24,    24,    51,    51,    47,    21,    38,    38,
      38,    38,    45,    45,    24,    24,    24,    24,    22,    47,
      45,    22
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    40,    41,    41,    41,    41,    42,    43,    43,    44,
      44,    45,    45,    45,    46,    46,    46,    47,    47,    48,
      48,    49,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    52,    53,    53,
      53,    53,    54,    55,    55,    55,    56,    56,    57,    57,
      58,    58,    59,    59,    60,    60
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     1,     1,     1,     1,
       2,     0,     1,     1,     5,    13,    11,     1,     2,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     4,     2,     3,     6,     4,     4,
       4,     4,     4,     6,     6,     6,     6,     8,     6,     8,
       3,     4,     6,     8,     6,     8
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 337 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1644 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 338 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1650 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 339 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1656 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 340 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1662 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 344 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1668 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 348 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1674 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 349 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1680 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 353 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1686 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 354 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1692 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 358 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1698 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 359 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1704 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 360 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1710 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 364 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = -1;
			realloc_packet();
		}
#line 1719 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 368 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = (yyvsp[-10].number);
			max_cpu = (yyvsp[-8].number);

			if (min_cpu > max_cpu) {
				int tmp = min_cpu;

				min_cpu = max_cpu;
				max_cpu = tmp;
			}

			realloc_packet();
		}
#line 1737 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 381 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = (yyvsp[-8].number);
			realloc_packet();
		}
#line 1746 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 388 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1752 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 389 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1758 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 393 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1764 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 394 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1770 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 398 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1776 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 402 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[0].number)); }
#line 1782 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 403 "trafgen_parser.y" /* yacc.c:1646  */
    { set_multi_byte((uint8_t *) (yyvsp[0].str) + 1, strlen((yyvsp[0].str)) - 2); }
#line 1788 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 404 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1794 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 405 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1800 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 406 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1806 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 407 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1812 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 408 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1818 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 409 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1824 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 410 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1830 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 411 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1836 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 412 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1842 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 413 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1848 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 418 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); }
#line 1854 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 420 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 1860 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 422 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 1866 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 424 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 1872 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 426 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number); }
#line 1878 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 428 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) % (yyvsp[0].number); }
#line 1884 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 430 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) & (yyvsp[0].number); }
#line 1890 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 432 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) | (yyvsp[0].number); }
#line 1896 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 434 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) ^ (yyvsp[0].number); }
#line 1902 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 436 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) << (yyvsp[0].number); }
#line 1908 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 438 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) >> (yyvsp[0].number); }
#line 1914 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 440 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = -1 * (yyvsp[0].number); }
#line 1920 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 442 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number);}
#line 1926 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 447 "trafgen_parser.y" /* yacc.c:1646  */
    { set_fill((yyvsp[-3].number), (yyvsp[-1].number)); }
#line 1932 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 452 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[-1].number)); }
#line 1938 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 453 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint16_t __c = cpu_to_be16((uint16_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 1948 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 458 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint32_t __c = cpu_to_be32((uint32_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 1958 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 463 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint64_t __c = cpu_to_be64((uint64_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 1968 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 472 "trafgen_parser.y" /* yacc.c:1646  */
    { set_rnd((yyvsp[-1].number)); }
#line 1974 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 477 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_IP); }
#line 1980 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 479 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP); }
#line 1986 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 481 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP); }
#line 1992 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 486 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 1998 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 488 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2004 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 493 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2010 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 495 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2016 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 500 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_rnd(); }
#line 2022 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 502 "trafgen_parser.y" /* yacc.c:1646  */
    {
			int i, max = (yyvsp[-1].number);
			for (i = 0; i < max; ++i)
				set_dynamic_rnd();
		}
#line 2032 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 511 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_INC); }
#line 2038 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 513 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_INC); }
#line 2044 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 518 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_DEC); }
#line 2050 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 520 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_DEC); }
#line 2056 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;


#line 2060 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 523 "trafgen_parser.y" /* yacc.c:1906  */


static void finalize_packet(void)
{
	/* XXX hack ... we allocated one packet pointer too much */
	plen--;
	dlen--;
}

static void dump_conf(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		printf("[%zu] pkt\n", i);
		printf(" len %zu cnts %zu rnds %zu\n",
		       packets[i].len,
		       packet_dyn[i].clen,
		       packet_dyn[i].rlen);

		printf(" payload ");
		for (j = 0; j < packets[i].len; ++j)
			printf("%02x ", packets[i].payload[j]);
		printf("\n");

		for (j = 0; j < packet_dyn[i].clen; ++j)
			printf(" cnt%zu [%u,%u], inc %u, off %ld type %s\n", j,
			       packet_dyn[i].cnt[j].min,
			       packet_dyn[i].cnt[j].max,
			       packet_dyn[i].cnt[j].inc,
			       packet_dyn[i].cnt[j].off,
			       packet_dyn[i].cnt[j].type == TYPE_INC ?
			       "inc" : "dec");

		for (j = 0; j < packet_dyn[i].rlen; ++j)
			printf(" rnd%zu off %ld\n", j,
			       packet_dyn[i].rnd[j].off);
	}
}

void cleanup_packets(void)
{
	size_t i;

	for (i = 0; i < plen; ++i) {
		if (packets[i].len > 0)
			xfree(packets[i].payload);
	}

	free(packets);

	for (i = 0; i < dlen; ++i) {
		free(packet_dyn[i].cnt);
		free(packet_dyn[i].rnd);
	}

	free(packet_dyn);
}

int compile_packets(char *file, int verbose, int cpu, bool invoke_cpp)
{
	char tmp_file[128];

	memset(tmp_file, 0, sizeof(tmp_file));
	our_cpu = cpu;

	if (invoke_cpp) {
		char cmd[256], *dir, *base, *a, *b;

		dir = dirname((a = xstrdup(file)));
		base = basename((b = xstrdup(file)));

		slprintf(tmp_file, sizeof(tmp_file), "%s/.tmp-%u-%s", dir, rand(), base);
		slprintf(cmd, sizeof(cmd), "cpp -I" ETCDIRE_STRING " %s > %s",
			 file, tmp_file);
		if (system(cmd) != 0)
			panic("Failed to invoke C preprocessor!\n");

		file = tmp_file;
		xfree(a);
		xfree(b);
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin)
		panic("Cannot open %s: %s!\n", file, strerror(errno));

	realloc_packet();
	yyparse();
	finalize_packet();

	if (our_cpu == 0 && verbose)
		dump_conf();

	fclose(yyin);
	if (invoke_cpp)
		unlink(tmp_file);

	return 0;
}

void yyerror(const char *err)
{
	panic("Syntax error at line%d, at char '%s'! %s!\n", yylineno, yytext, err);
}
